<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Target Machine Parameters</TITLE>
<link href="suif1_104.html" rel=Next>
<link href="suif1_102.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_102.html">previous</A>, <A HREF="suif1_104.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC103" HREF="suif1_toc.html#TOC103">Target Machine Parameters</A></H2>
<P>
<A NAME="IDX729"></A>

</P>
<P>
<A NAME="IDX730"></A>
<A NAME="IDX731"></A>
The SUIF library includes a structure to record various parameters of
the target machine.  The back-end of the compiler may be either a code
generator for a specific processor or the system's C compiler, using the
SUIF-to-C translator.  Thus, the target machine parameters include
fields that deal both with hardware requirements and with details of the
back-end C compiler.  These parameters are stored in the <CODE>target</CODE>
<CODE>machine_params</CODE> structure.  The front-end is responsible for
setting the target parameters, but they are then saved in the SUIF files
and passed along to all subsequent passes of the compiler.

</P>
<P>
The first fields in the <CODE>machine_params</CODE> structure deal with the
addressing in the underlying hardware.  The <CODE>is_big_endian</CODE> field
specifies the byte order, and the <CODE>addressable_size</CODE> field
specifies the size in bits of the smallest addressable unit.  Since most
machines are byte-addressable, the <CODE>addressable_size</CODE> is usually
set to eight.

</P>
<P>
<A NAME="IDX732"></A>
Next, the sizes and alignments for various C types are specified.  The
possible C types are listed in the <CODE>C_types</CODE> enumeration:

</P>
<DL COMPACT>

<DT><CODE>C_char</CODE>
<DD>
<DT><CODE>C_short</CODE>
<DD>
<DT><CODE>C_int</CODE>
<DD>
<DT><CODE>C_long</CODE>
<DD>
<DT><CODE>C_longlong</CODE>
<DD>
<DT><CODE>C_float</CODE>
<DD>
<DT><CODE>C_double</CODE>
<DD>
<DT><CODE>C_longdouble</CODE>
<DD>
<DT><CODE>C_ptr</CODE>
<DD>
</DL>

<P>
The <CODE>size</CODE> and <CODE>align</CODE> fields of the <CODE>machine_params</CODE>
structure are arrays containing the size and alignment for each C type.
Both are specified in bits (not bytes).  Some C compilers require
additional alignment restrictions for arrays and structures.  The
<CODE>array_align</CODE> and <CODE>struct_align</CODE> fields contain these
alignment requirements in bits.  Note that these do not replace the
alignment restrictions for the components of an array or structure; the
most restrictive alignments must always be maintained.

</P>
<P>
The remaining fields are only applicable to the back-end C compiler.
The <CODE>char_is_signed</CODE> field specifies if the default <CODE>char</CODE>
type is signed.  This is just to allow the SUIF-to-C translator to avoid
cluttering up the C code by explicitly putting <CODE>signed</CODE> or
<CODE>unsigned</CODE> in every declaration of a <CODE>char</CODE> type.  When two
pointers are subtracted in C, the result type is implementation defined.
The <CODE>ptr_diff_type</CODE> field in <CODE>machine_params</CODE> specifies the
type produced by such pointer subtractions for use in SUIF-to-C.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_102.html">previous</A>, <A HREF="suif1_104.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
